---
title: HTMLTableElement.insertRow()
slug: Web/API/HTMLTableElement/insertRow
tags:
  - API
  - HTML DOM
  - HTMLTableElement
  - Method
  - NeedsMobileBrowserCompatibility
  - Reference
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLTableElement.insertRow()</code></strong> method inserts a new row ({{HtmlElement("tr")}}) in a given {{HtmlElement("table")}}, and returns a reference to the new row.</p>

<p>If a table has multiple {{HtmlElement("tbody")}} elements, by default, the new row is inserted into the last <code>&lt;tbody&gt;</code>. To insert the row into a specific <code>&lt;tbody&gt;</code>:</p>

<pre class="brush: js">let specific_tbody = document.getElementById(tbody_id);
let row = specific_tbody.insertRow(index)</pre>


<div class="notecard note">
<p><strong>Note:</strong> <code>insertRow()</code> inserts the row directly into the table. The row does not need to be appended separately as would be the case if {{domxref("Document.createElement()")}} had been used to create the new <code>&lt;tr&gt;</code> element.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>newRow</em> = <em>HTMLTableElement</em>.insertRow(<em>index</em>);</pre>

<p>{{domxref("HTMLTableElement")}} is a reference to an HTML {{HtmlElement("table")}} element.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>index</code> {{optional_inline}}</dt>
 <dd>The row index of the new row. If <code>index</code> is <code>-1</code> or equal to the number of rows, the row is appended as the last row. If <code>index</code> is greater than the number of rows, an <code>IndexSizeError</code> exception will result. If <code>index</code> is omitted it defaults to <code>-1</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>newRow</code> is an {{domxref("HTMLTableRowElement")}} that references the new row.</p>

<h2 id="Example">Example</h2>

<p>This example uses <code>insertRow(-1)</code> to append a new row to a table.</p>

<p>We then use {{domxref("HTMLTableRowElement.insertCell()")}} to insert a new cell in the new row. (To be valid HTML, a <code>&lt;tr&gt;</code> must have at least one <code>&lt;td&gt;</code> element.) Finally, we add some text to the cell using {{domxref("Document.createTextNode()")}} and {{domxref("Node.appendChild()")}}.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;table id="my-table"&gt;
  &lt;tr&gt;&lt;td&gt;Row 1&lt;/td&gt;&lt;/tr&gt;
  &lt;tr&gt;&lt;td&gt;Row 2&lt;/td&gt;&lt;/tr&gt;
  &lt;tr&gt;&lt;td&gt;Row 3&lt;/td&gt;&lt;/tr&gt;
&lt;/table&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">function addRow(tableID) {
  // Get a reference to the table
  let tableRef = document.getElementById(tableID);

  // Insert a row at the end of the table
  let newRow = tableRef.insertRow(-1);

  // Insert a cell in the row at index 0
  let newCell = newRow.insertCell(0);

  // Append a text node to the cell
  let newText = document.createTextNode('New bottom row');
  newCell.appendChild(newText);
}

// Call addRow() with the table's ID
addRow('my-table');</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "tables.html#dom-table-insertrow", "HTMLTableElement.insertRow()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("DOM2 HTML", "html.html#ID-93995626", "HTMLTableElement.insertRow()")}}</td>
   <td>{{Spec2("DOM2 HTML")}}</td>
   <td>Specifies in more detail where the row is inserted.</td>
  </tr>
  <tr>
   <td>{{SpecName("DOM1", "level-one-html.html#ID-39872903", "HTMLTableElement.insertRow()")}}</td>
   <td>{{Spec2("DOM1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLTableElement.insertRow")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("HTMLTableRowElement.insertCell()")}}</li>
 <li>The HTML element representing rows: {{domxref("HTMLTableRowElement")}}</li>
</ul>
